/*
   The following C code checks the Dallas Semiconductor 1-Wire CRC of the
   data in the 8 byte array romdta. The function checkdow() initializes
   the cumulative crc byte (crc) and computes the DOW crc of all eight
   bytes. It returns 1 (true) if crc = 0 and 0 (false) otherwise.
*/

unsigned char crc,romdta[8];

///////////////////////////////////// for test
#include <stdio.h>

unsigned char checkdow(void);
unsigned char crc8(int);

void main(void)
{
     romdta[0] = 0x04;
     romdta[1] = 0xB6;
     romdta[2] = 0x20;
     romdta[3] = 0x06;
     romdta[4] = 0x00;
     romdta[5] = 0x00;
     romdta[6] = 0x00;
     romdta[7] = 0xB0;

     printf("checkdow %d\n",checkdow());
}
///////////////////////////////////// for test

unsigned char checkdow()
{
   int k;

   crc = 0;
   for (k = 0; k < 8; k++) crc8(romdta[k]);
   return !crc;
}

unsigned char crc8(int data)
{
   int i;
   int f;

   data = data & 0xff;

   for (i = 0; i < 8; ++i)
   {
      f    = 1 & (data ^ crc);
      crc  = crc  >> 1;
      data = data >> 1;
      if (f) crc = crc ^ 0x8c;
   }
   return crc;
}

