{
   The following pascal code checks the Dallas Semiconductor 1-Wire CRC of
   the data in the 8 byte array romdta. The function CheckDOW initializes
   the cummulative crc byte (CRC) and computes the DOW crc of all eight
   bytes. It returns True if CRC = 0 and False otherwise.
}

Var
   RomDta : Array[1..8] of Byte;
   CRC    : Byte;

Procedure DOWCRC(CB: Byte);
{
  This procedure accumulates the one-wire CRC of the data passed to
  it in the variable CRC.
}

Var
  I : Byte;
  F : Boolean;

Begin
  For I := 1 to 8 do Begin
    F := Odd(CB xor CRC);
    CRC := CRC shr 1;
    CB := CB shr 1;
    If F then CRC := CRC xor 140;
  End;
End;

Function CheckDOW: Boolean;

Var
   J : Byte;

Begin
   CRC := 0;
   For J := 1 to 8 Do DOWCRC(RomDta[J]);
   CheckDOW := (CRC = 0);
End;

Begin
End.