Program MakeD;                      { Version 0.00   SMC   11/02/91 }
{
   This program collects text data from the keyboard and writes it
   into a DS1993. In this version, line feeds must be entered
   explicitly, as <ctrl-J>, in order to be included in the data.
   The program writes through the serial port adapter. To exit
   the text entry mode and write the text into the DS1993, press
   the ~ key.
}

Uses DOS, CRT, TouchS;                  { Required Pascal I/O units }

Var
   CRC : Word;

Procedure CRC16(X: Byte);
{
   This procedure accumulates the CRC16 CRC of the data X in the
   global variable CRC.
}

Var
   I : Byte;
   F : Boolean;

Begin
   For I := 1 to 8 do Begin
      F := Odd(X xor CRC);
      CRC := CRC shr 1;
      X := X shr 1;
      If F then CRC := CRC xor $A001;
   End;
End;

Procedure WByte(X: Byte);
{
   This procedure transmits the byte X to the Touch Memory.
}

Begin
   X := TouchByte(X);
End;

Function RByte: Byte;
{
   This function returns the byte received from a Touch Memory.
}

Begin
   RByte := TouchByte($FF);
End;

Var
   SP           : Array[1..4] of Word Absolute $40:0;
   X, Y         : Array[0..508] of Word;
   K            : Array[0..507] of Byte;
   D            : Array[0..511] of Byte;
   L            : LongInt;
   M, N, SX, SY : Word;
   S, I, J,  P  : Byte;
   C            : Char;

Begin                               { Main program code begins here }
   S := 1;                                        { Default to COM1 }
   If ParamCount > 0 then Begin
      {$R+}
      Val(ParamStr(1), L, N);  { Get COM port number from cmd line }
      {$R-}
      If (N > 0) or (L < 1) or (L > 4) then Begin
         WriteLn('INCORRECT COMMAND LINE PARAMETER');
         Halt;
      End else S := L;
   End;
   If SP[S] = 0 then WriteLn('COM', L, ' DOES NOT EXIST') else Begin
      TextColor(Yellow); TextBackground(Blue); ClrScr;
      WriteLn('ENTER TEXT BELOW'); WriteLn;
      N := 0; C := ReadKey;
      X[N] := WhereX; Y[N] := WhereY;
      While C <> '~' do Begin
         If C = #8 then Begin
            If N = 0 then Begin
               Sound(440); Delay(20); NoSound;
            End else Begin
               Dec(N); GotoXY(X[N], Y[N]);
               If K[N] > $20 then Begin
                  Write(' '); GotoXY(X[N], Y[N]);
               End;
            End;
         End else Begin
            If N = 508 then Begin
               Sound(440); Delay(20); NoSound;
            End else Begin
               K[N] := Byte(C); Inc(N); Write(C);
               If C = #13 then Begin
                 Write(#10); 
                 K[N] := 10;
                 Inc(N);
               End;
               X[N] := WhereX; Y[N] := WhereY;
            End;
         End;
         SX := WhereX; SY := WhereY;
         GotoXY(1, 25); ClrEol;
         Write(508 - N);
         GotoXY(SX, SY);
         C := ReadKey;
      End;
      WriteLn; WriteLn;
      M := 0; CRC := 0;
      If N < 255 then D[M] := N else Begin
         D[M] := 255; CRC16(D[M]);
         Inc(M); D[M] := N - 255;
      End;
      CRC16(D[M]); Inc(M);
      If N > 0 then For SX := 0 to Pred(N) do Begin
         D[M] := K[SX]; CRC16(D[M]); Inc(M);
      End;
      D[M] := not Lo(CRC); Inc(M);
      D[M] := not Hi(CRC);
      P := M shr 5; Inc(M);
      WriteLn('PLEASE TOUCH DS1993'); WriteLn;
      N := 0;
      Repeat
         If KeyPressed and (ReadKey = #27) then Halt;
         For I := 0 to P do Begin
            If TouchReset(S) then Begin
               WByte($CC); WByte($F);
               WByte(I shl 5); WByte(I shr 3);
               For J := 0 to 31 do WByte(D[I shl 5 or J]);
            End;
            If TouchReset(S) then Begin
               WByte($CC); WByte($55);
               WByte(I shl 5); WByte(I shr 3); WByte(31)
            End;
         End;
         If TouchReset(S) then Begin
            WByte($CC); WByte($F0);
            WByte(0); WByte(0); N := 0;
            While (N < M) and (RByte = D[N]) do Inc(N);
         End;
      Until N = M;
   End;
End.


