Program Convert;   { Version 1.00   SMC   October 19, 1991 }

{
   This program tests the algorithm used for conversion between
   standard date format and days since the beginning of 1970.
}

Const
   DM : Array[1..13] of Word = (0,31,59,90,120,151,181,212,243,273,304,334,365);

Procedure U2D(I: LongInt; Var YR, MO, DA: LongInt);
{
   Convert from Day to Date.
}

Var
   J, N : LongInt;

Begin
   N := (I + 731) shl 2; YR := N div 1461;
   N := (N - 1461 * YR) shr 2;
   MO := 1 + (N + 1) div 30;
   J := DM[MO] + Byte((MO > 2) and (YR and 3 = 0));
   If N < J then Begin
      Dec(MO);
      J := DM[MO] + Byte((MO > 2) and (YR and 3 = 0));
   End;
   DA := N - J + 1; YR := YR + 1968;
End;

Procedure D2U(YR, MO, DA: LongInt; Var N: LongInt);
{
   Convert from Date to Day.
}

Begin
   N := 365 * (YR - 1970) + (YR - 1969) shr 2 + DM[MO]
      + DA + Byte((MO > 2) and (YR and 3 = 0)) - 1;
End;

Var
   YR, MO, DA, I, N : LongInt;

Begin
   {
      The following code tests the format conversion procedures by
      converting every day since January 1, 1970 into a standard date,
      checking the validity of that date, converting it back again to
      the number of days since January 1, 1970, and confirming that
      the day number did not change.
   }
   For I := 0 to 47540 do Begin
      {
         Convert from Day to Date.
      }
      U2D(I, YR, MO, DA);
      {
         Display any invalid Dates.
      }
      If (MO < 1) or (MO > 12) or (DA < 1) or
      (DA > DM[MO + 1] - DM[MO] + Byte((MO = 2) and (YR and 3 = 0)))
      then WriteLn(MO, '/', DA, '/', YR);
      {
         Convert from Date to Day.
      }
      D2U(YR, MO, DA, N);
      {
         Compare the results and display any errors.
      }
      If I <> N then WriteLn(I, ' ', N, ' ', MO, '/', DA, '/', YR);
   End;
   {
      The absence of any printed output when this program is executed
      indicates that the date conversion procedures have performed
      correctly.
   }
End.
